# NOTE: Derived from blib/lib/BDB/Wrapper.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package BDB::Wrapper;

#line 958 "blib/lib/BDB/Wrapper.pm (autosplit into blib/lib/auto/BDB/Wrapper/create_write_dbh.al)"
sub create_write_dbh(){
  my $self=shift;
  my $bdb=shift;
  my $op='';
  if($bdb && ref($bdb) eq 'HASH'){
    $op=$bdb;
    $bdb=$op->{'bdb'};
  }
  else{
    $op=shift;
    $op->{'bdb'}=$bdb;
  }
  
  $op->{'bdb'}=File::Spec->rel2abs($op->{'bdb'});

  my $transaction = undef;
  my $hash=0;
  my $dont_try=0;
  my $sort_code_ref=undef;
  if(ref($op) eq 'HASH'){
    $hash=$op->{'hash'} || 0;
    $dont_try=$op->{'dont_try'} || 0;
    if(exists($op->{'transaction'})){
      $transaction = $op->{'transaction'};
    }
    elsif(exists($op->{'txn'})){
      $transaction = $op->{'txn'};
    }
    else{
      $transaction = $self->{'transaction'};
    }
    if($transaction && $transaction!~ m!^/.!){
      $transaction = $self->{'default_txn_dir'};
    }
    if($op->{'reverse'} || $op->{'reverse_num'}){
      $sort_code_ref=sub {$_[1] <=> $_[0]};
    }
    elsif($op->{'reverse_cmp'}){
      $sort_code_ref=sub {$_[1] cmp $_[0]};
    }
    elsif($op->{'sort'} || $op->{'sort_num'}){
      $sort_code_ref=sub {$_[0] <=> $_[1]};
    }
    else{
      $sort_code_ref=$op->{'sort_code_ref'};
    }
  }
  else{
    $hash=$op || 0;
    $dont_try=shift || 0;
    $sort_code_ref=shift;
  }
  my $env;
  
  if($op->{'no_env'}){
    $env=undef;
  }
  else{
    $env=$self->create_env({'bdb'=>$op->{'bdb'}, 'cache'=>$op->{'cache'}, 'no_lock'=>$op->{'no_lock'}, 'transaction'=>$transaction});
  }
  
  my $bdb_dir=$op->{'bdb'};
  $bdb_dir=~ s!/[^/]+$!!;
  
  my $dbh;
  
  if($no_lock){
    $self->rmkdir($bdb_dir);
    if($hash){
      $dbh =new BerkeleyDB::Hash {
        -Filename => $op->{'bdb'},
        -Flags => DB_CREATE,
        -Mode => 0666,
        -Env => $env
        };
    }
    else{
      $dbh =new BerkeleyDB::Btree {
        -Filename => $op->{'bdb'},
        -Flags => DB_CREATE,
        -Mode => 0666,
        -Env => $env,
        -Compare => $sort_code_ref
        };
    }
  }
  else{
    $SIG{ALRM} = sub { die "timeout"};
    eval{
      alarm($self->{'wait'});
      $self->rmkdir($bdb_dir);
      if($hash){
        $dbh =new BerkeleyDB::Hash {
          -Filename => $op->{'bdb'},
          -Flags => DB_CREATE,
          -Mode => 0666,
          -Env => $env
          };
      }
      else{
        $dbh =new BerkeleyDB::Btree {
          -Filename => $op->{'bdb'},
          -Flags => DB_CREATE,
          -Mode => 0666,
          -Env => $env,
          -Compare => $sort_code_ref
          };
      }
      alarm(0);
    };

    unless($dont_try){
      if($@){
        if($@ =~ /timeout/){
          $op->{'dont_try'}=1;
          $dont_try=1;
          my $home_dir=$self->get_bdb_home({'bdb'=>$bdb, 'transaction'=>$transaction});
          system('rm -rf '.$home_dir) if ($home_dir=~ m!^(?:/tmp/bdbwrapper|/dev/shm)! && -d $home_dir);
          if(ref($op) eq 'HASH'){
            $op->{'dont_try'}=1;
            return $self->create_write_dbh($op);
          }
          else{
            return $self->create_write_dbh($bdb, $dont_try, $sort_code_ref);
          }
        }
        else{
          alarm(0);
        }
      }
    }
  }
  
  if(!$dbh){
    {
      local $|=0;
      print "Content-type:text/html\n\nFailed to create write dbh for ";
      print $op->{'bdb'}.'<br />'."\n";
      print "Please inform this error to this site's administrator.";
      exit;
    }
  }
  else{
    if(wantarray){
      return ($dbh, $env);
    }
    else{
      return $dbh;
    }
  }
}

# end of BDB::Wrapper::create_write_dbh
1;
